'use strict';

const format = require('./format.js');

const getLabel = (lane) => {
    if (typeof lane !== 'object') {
        lane = {};
    }
    const fmt = lane.format || '%h';
    const width = Number(lane.width || 1);
    const formatter = format(fmt, width);

    return (value, mask, x, w) => {

        if (mask) {
            if (value) {
                return ['text', { x, class: 'unknown' }, '?'];
            } else {
                return ['text', { x, class: 'high-impedance' }, 'x'];
            }
        }


        const pos = (w / 8) | 0;

        value = BigInt(value);

        const txtShort = formatter(value, pos, width);

        return ['text', { x, class: 'common' }, txtShort];
    };
};

module.exports = getLabel;
